var Site = {

	startJqForm: function(){
		if ($('#download')) Site.download();
		if ($("#process")) Site.process();
	},

	process: function() {
		$('#select_all').click(function(e) {
			$("#process input.extkey").each(function(id, input) {
				input.checked = true;
			});
		});
		$('#select_none').click(function(e) {
			$("#process input.extkey").each(function(id, input) {
				input.checked = false;
			});
		});
	},

	download: function(){
		$('input[deps]').each(function(id, input) {
			$(input).click(function(event) {
				Site.toggleDeps(this);
			});
		});
		$('#select_all').click(function() {
			$('input[deps]').each(function(id, input) {
				Site.check(input);
			});
		});
		$('#select_none').click(function(){
			$('input[deps]').each(function(id, input) {
				Site.uncheck(input);
			});
		});
	},

	toggleDeps: function(input) {
		if (input.checked) {
			Site.check(input);
		} else {
			Site.uncheck(input);
		}
	},

	uncheck: function(input) {
		$(input).attr('checked', false);
		var deps = $(input).attr('deps');
		if (deps) {
			Site.uncheckDepending($(input).attr('id'));
		}
	},

	check: function(input) {
		$(input).attr('checked', true);
		var deps = $(input).attr('deps');
		if (deps) {
			Site.checkDependants(deps.split(','));
		}
		var dist = $(input).attr('dist');
		if (dist) {
			Site.uncheckDisturbing(dist.split(','));
		}
	},

	checkDependants: function(deps) {
		$(deps).each(function(id, input) {
			if ($("#"+input).length && $("#"+input).attr('checked') == false) {
				Site.check($("#"+input));
			}
		});
	},

	uncheckDepending: function(component) {
		$('input[deps]:checked').each(function(id, input) {
			if ($.inArray(component, $(input).attr('deps').split(',')) != -1) {
				Site.uncheck(input);
			}
		});
	},

	uncheckDisturbing: function(component) {
		$('input[deps]:checked').each(function(id, input) {
			if ($.inArray(input.id, component) != -1) {
				Site.uncheck(input);
			}
		});
	},


	checkLoaded: function() {
		$('input[deps]:checked').each(function(id, input) {
			var deps = $(input).attr('deps').split(',');
			$(deps).each(function(id2, dep){
				Site.check($("#"+dep));
			});
		});
	}
};

$(document).ready(function() {
	Site.startJqForm();
	Site.checkLoaded();
});
